# This is the file to compare the results of different possible models
# run it after you run the part1 file


for(ModelNr in 1:2){   # there should always be a model 1    
  
  # Model 2 is the model we use in the published paper 
  
  # For a list of variable use cbind(variables, index)
  if(ModelNr==1){ # 
    # "rural" "head_age" "edu" "ihs_non_food_exp_person" "servants_new" "no" "floor_house_new"
    # Explaining Vars: 
    choice   <- c(2,5,7,39,3,20)              
  } 

  if(ModelNr==2){ # add "servants_new"
    # "rural" "head_age" "edu" "ihs_non_food_exp_person" "servants_new" "no" "flusing_toilet"
    # Explaining Vars: 
    choice   <- c(2,5,7,39,45,3,20)              
  } 
  
  if(ModelNr==3){ # drop "servants_new"
    # "rural" "head_age" "edu" "ihs_non_food_exp_person" "servants_new" "no" "ihs_floor_house_new"
    # Explaining Vars: 
    choice   <- c(2,5,7,39,3,20, 47)              
  } 
    
  if(ModelNr==4){ # drop "servants_new"
    # "rural" "head_age" "edu" "ihs_non_food_exp_person" "servants_new" "no" "ihs_floor_house_new"
    # Explaining Vars: 
    choice   <- c(2,5,7,39,45,3,20, 47)              
  } 
  
  if(ModelNr==5){ # drop size of the house "floor_house_new"
    # "rural" "head_age" "edu" "ihs_non_food_exp_person" "servants_new" "no" "floor_house_new"
    # Explaining Vars: 
    choice   <- c(2,5,7,39,18,3,20)              
  } 
  
  if(ModelNr==6){ # drop "servants_new"
    # "rural" "head_age" "edu" "ihs_non_food_exp_person" "servants_new" "no" "ihs_floor_house_new"
    # Explaining Vars: 
    choice   <- c(2,5,7,39,3,20, 43)              
  } 
  
  if(ModelNr==7){ # drop "servants_new"
    # "rural" "head_age" "edu" "ihs_non_food_exp_person" "servants_new" "no" "ihs_floor_house_new"
    # Explaining Vars: 
    choice   <- c(2,5,7,39,18,3,20, 43)              
  } 
  
  if(ModelNr==8){ # drop "servants_new"
    # "rural" "head_age" "edu" "ihs_non_food_exp_person" "servants_new" "no" "ihs_floor_house_new"
    # Explaining Vars: 
    choice   <- c(2,5,7,39,45,3,20, 47, 42)
  } 
  
  
  
  
  
  elementFormula<-character()
  for(i in choice){
    elementFormula<-paste(elementFormula,"+","b",i,"*",variables[i], sep="")
  }
  ExpFormula1<- paste("ed ~ I(exp(1)^(b1", elementFormula, "))" , sep="")
  
  ListStart<-list()
  for(i in c(1,choice)){
    ListStart[paste("b",i,sep="")] = startvalues[i]
  }
  
  
  
  ExpStartvalue1 <- ListStart
  
  expMod1<- nls( formula=ExpFormula1, 
                 start=  ExpStartvalue1,
                 data=electken2,
                 trace=TRUE, 
                 control=list(maxiter=100000), 
                 weights=weight,
                 #algorithm ="plinear", 
                 #algorithm="port",
                 model= TRUE
                 )
  
  
  # Summary of model results          
  summary(expMod1)
  t(cbind(choice, variables[choice]))
  
  # Prediction: predict for the household of the sample and multiply by the weights
  predictExp1_unweighted<-predict(expMod1, electken1)
  predictExp1_weighted<-predictExp1_unweighted*electken1$weight
  # Predicted Sum of electricity demand in each district
  Predict_exp1_sum<-tapply(X=predictExp1_weighted,INDEX=electken1$district,FUN=sum, na.rm=TRUE)
  # calculate how many households are represented in each district by the sample
  total_represented <- tapply(X=electken1$weight,INDEX=electken1$district,FUN=sum, na.rm=TRUE)
  #  Predicted Mean of electricity demand in each district  
  Predict_exp1_mean<- Predict_exp1_sum/total_represented  
  # count number of observations in each group  
  tempFUN<- function(X)sum(!is.na(X))
  Predict_exp1_nobs <- tapply(X=predictExp1_weighted,INDEX=electken1$district,FUN=tempFUN)
  
  
  # for comparison with observed electricity demand:
  observed_weighted<-electken2$ed*electken2$weight[is.na(electken2$ed)==FALSE]
  # Predicted Sum of electricity demand in each district
  Observed_grid_sum<-tapply(X=observed_weighted,INDEX=electken2$district,FUN=sum, na.rm=TRUE)
  Observed_grid_mean<-tapply(X=observed_weighted,INDEX=electken2$district,FUN=mean, na.rm=TRUE)
  Observed_grid_exp1_nobs <- tapply(X=observed_weighted,INDEX=electken2$district,FUN=tempFUN)
  
  
  #      Observed_all_sum<-tapply(X=electken1$ed,INDEX=electken1$district,FUN=sum, na.rm=TRUE)
  #      Observed_all_mean<-tapply(X=electken1$ed,INDEX=electken1$district,FUN=mean, na.rm=TRUE)
  #      Observed_all_nobs <- tapply(X=electken1$ed,INDEX=electken1$district,FUN=tempFUN)
  
  predicted_district_electricity_demand<- cbind(Predict_exp1_sum, Predict_exp1_mean, Predict_exp1_nobs,
                                                Observed_grid_sum,Observed_grid_mean, Observed_grid_exp1_nobs)
  #                                                    Observed_all_sum,Observed_all_mean, Observed_all_nobs)
  colnames(predicted_district_electricity_demand)<-c("Predicted_all_exp1_sum","Predicted_all_exp1_mean", "Predict_exp1_nobs",
                                                     "Observed_grid_sum","Observed_grid_mean","Observed_grid_exp1_nobs" )
  #                                                            "Observed_all_sum","Observed_all_mean",  "Observed_all_nobs" )
  barplot(height=cbind(Observed_grid_mean, Predict_exp1_mean), 
          beside=TRUE)
  
  #          plot(
  #           predicted_district_electricity_demand[,"Predicted_all_exp1_mean"],
  #           predicted_district_electricity_demand[,"Observed_grid_mean"]
  #           , xlim=c(0,1000)
  #           , ylim=c(0,1000)
  #           )
  
  #  colSums(predicted_district_electricity_demand, na.rm=TRUE)
  
  # # The following is a not a good idea, because predictExp1_all is the delmand mulitplied with the weight
  #    plot(sort(electken1$ed), ylim=c(0,max(predictExp1_all, na.rm=TRUE)),type="n", ylab="Predicted Electricity Consumption", lwd=2)
  #     #points(sort(electken1$ed), col="black", pch=".")
  #    abline(h=0)
  #    points(sort(predictExp1_all), col="blue", pch=".")
  
  
  #################################
  # Multi hurdle models
  
  
  # Tobit
  elementFormula_hurdle<-character()
  for(i in choice){
    elementFormula_hurdle<-paste(elementFormula_hurdle,"+",variables[i], sep="")
  }
  TobitFormula1<- paste("ed ~ 0|1", elementFormula_hurdle, "|0" , sep="")
  TobitFormula1<- as.formula(TobitFormula1)
  
  # Estimate Tobit Model
  TobitMod1<- mhurdle(TobitFormula1 , data=electken2, 
                      dist = "n", method = "nr", weights=electken2$weight)
   
  # "bfgs"
  # "nr"
  # "bhhh"
  
  summary(TobitMod1)
  
  ### write a function for marginal effects for the censored sample
  
  margEffectsTobit<- function(object, data = object$model[,-c(1,ncol(object$model))] ){
    coeff= object$coefficients[-length(object$coefficients)]
    data <-   t(cbind(1,data ))         
    xbeta<- coeff %*% data
    margEffectsCensoredEach<-  rep(coeff, each=ncol(data))*rep(dnorm(xbeta/object$coefficients["sigma"]), each=nrow(data))
    margEffectsCensored<- tapply(X=margEffectsCensoredEach, INDEX=rep(1:length(coeff),each=ncol(data)), FUN=mean)
    return(as.vector(margEffectsCensored))
  }
  
  margEffectsTobit(TobitMod1)


  
  # write a function for prediction for mhurdle Tobit model
  # object must be an estimated Tobit model from mhurdle
  # data are either new data for predictions, if not specified the data the object was estimated with
  #       data must not contain a first column with 1, as this is added in the function.
  predictmhurdleTobit<- function(object, data = object$model[,-c(1,ncol(object$model))] ){
    coeff= object$coefficients[-length(object$coefficients)]
    data <-   t(cbind(1,data ))         
    xbeta<- coeff %*% data
    tobit_Cond_demand<-xbeta+((dnorm(xbeta/object$coefficients["sigma"])/
      pnorm(xbeta/object$coefficients["sigma"]))*
      object$coefficients["sigma"])
    tobit_pre<-( (pnorm(xbeta/TobitMod1$coefficients["sigma"]))   * tobit_Cond_demand )
    return(as.vector(tobit_pre))
  }
  
  
 # calculate marginal effects for Dummy 
  
  margEffectsTobitDiscrete<- function(object, dummyName){
  dataDISCR  <- object$model[,-c(1,ncol(object$model))]
  dataDISCR0 <- dataDISCR
  dataDISCR0[,which(names(dataDISCR0)==dummyName)]<-0  
  dataDISCR1 <- dataDISCR
  dataDISCR1[,which(names(dataDISCR0)==dummyName)]<-1
  
  dummyEffectAll<-predictmhurdleTobit(object, data =dataDISCR1)-predictmhurdleTobit(object, data =dataDISCR0)
  return(mean(dummyEffectAll))
  }
 
  margEffectsTobitDiscrete(TobitMod1,"rural") 
  margEffectsTobitDiscrete(TobitMod1,"flusing_toilet")
  
  # xbeta for the models I estimated the 
  #       xbetaModel <- t(as.matrix(TobitMod1$coefficients[-length(TobitMod1$coefficients)]))  %*%
  #          t(cbind(1,TobitMod1$model[,-c(1,ncol(TobitMod1$model))] ))
  #        
  #        xbetaAll   <- t(as.matrix(TobitMod1$coefficients[-length(TobitMod1$coefficients)]))  %*%
  #         t(cbind(1,  electken1[,names(TobitMod1$model[,-c(1,ncol(TobitMod1$model))])] ))
  #        
  #        
  #        tobit_Cond_demand<-xbetaAll+((dnorm(xbetaAll/TobitMod1$coefficients["sigma"])/
  #          pnorm(xbetaAll/TobitMod1$coefficients["sigma"]))*
  #          TobitMod1$coefficients["sigma"])
  #        
  #        tobit_pre<-( (pnorm(xbetaAll/TobitMod1$coefficients["sigma"]))   * tobit_Cond_demand )
  #        #tobit_latent_pre<-predict(TobitMod1)[,2]              
  
  # Prediction: predict for the household of the sample and multiply by the weights
  predictTobit_unweighted <- predictmhurdleTobit(TobitMod1, data=electken1[,names(TobitMod1$model[,-c(1,ncol(TobitMod1$model))])])
  predictTobit_weighted<- predictTobit_unweighted*electken1$weight
  
  # Predicted Sum of electricity demand in each district
  Predict_Tobit_sum<-tapply(X=predictTobit_weighted,INDEX=electken1$district,FUN=sum, na.rm=TRUE)
  # Predicted Mean of electricity demand in each district  
  Predict_Tobit_mean<- Predict_Tobit_sum/total_represented  
  
  
  barplot(height=cbind(Observed_grid_mean, Predict_exp1_mean , Predict_Tobit_mean), 
          beside=TRUE)
  # Means
  barplot(height=t(cbind(Observed_grid_mean, Predict_exp1_mean , Predict_Tobit_mean)), 
          beside=TRUE)
  
  dev.copy2pdf( file="Mean_Electr_Demand.pdf",  paper="special")
  
  # Sums
  barplot(height=t(cbind(Observed_grid_sum, Predict_exp1_sum, Predict_Tobit_sum)), 
          beside=TRUE)
  
  
  predicted_district_electricity_demand <- cbind(predicted_district_electricity_demand, Predict_Tobit_sum, Predict_Tobit_mean)
  write.csv(predicted_district_electricity_demand, "predicted_district_electricity_demand.csv")
  
  Prediction_List[[ModelNr]] <-predicted_district_electricity_demand 
  
############################  
  # compare sum estimates of different ModelNr
###############  
  # Generate Dataframe for Exp1 Model sums Results
  # Exp Sums
  if(ModelNr==1)
  {sumsExp1_dataframe <- Prediction_List[[ModelNr]][,c("Predicted_all_exp1_sum")] }  else{       
    sumsExp1_dataframe <- data.frame(sumsExp1_dataframe,Prediction_List[[ModelNr]][,c("Predicted_all_exp1_sum")])}         
  
  barplot(height=
    t(sumsExp1_dataframe), 
          beside=TRUE, main="Exponential Sums", col=1:ModelNr)

  # Legend
  if(ModelNr==1)
  {legendvec <- paste("Model Nr", ModelNr)}  else{       
    legendvec <- c(legendvec, paste("Model Nr", ModelNr) )}         
  
  legend(x="topright", legend= legendvec,  col = 1:ModelNr,
         border="black", lty=1, lwd=2, pch="-",
         bty = "n", bg = par("bg"))                       

  dev.copy2pdf( file="Sum_Electr_Demand_Exp1_Comparisons.pdf",   width=30)
  
  # Tobit Sums
  
  if(ModelNr==1)
  {sumsTobit_dataframe <- Prediction_List[[ModelNr]][,c("Predict_Tobit_sum")] }  else{       
    sumsTobit_dataframe <- data.frame(sumsTobit_dataframe,Prediction_List[[ModelNr]][,c("Predict_Tobit_sum")])}         
  
  
  barplot(height=
    t(sumsTobit_dataframe), beside=TRUE, main="Tobit Sums", col=1:ModelNr)
  
  
  
  legend(x="topright", legend= legendvec,  col = 1:ModelNr,
         border="black", lty=1, lwd=2, pch="-",
         bty = "n", bg = par("bg"))                       

  dev.copy2pdf( file="Sum_Electr_Demand_Tobit_Comparisons.pdf",  width=30)
  
#########
  # Generate Dataframe for Exp1 means Model Reulst
  
  # Exp Means

  if(ModelNr==1)
  {meansExp1_dataframe <- Prediction_List[[ModelNr]][,c("Predicted_all_exp1_mean")] }  else{       
   meansExp1_dataframe <- data.frame(meansExp1_dataframe,Prediction_List[[ModelNr]][,c("Predicted_all_exp1_mean")])}         
 
   barplot(height=
    t(meansExp1_dataframe), 
          beside=TRUE, main="Exponential Means", col=1:ModelNr)
  
  legend(x="topright", legend= legendvec,  col = 1:ModelNr,
         border="black", lty=1, lwd=2, pch="-",
         bty = "n", bg = par("bg"))                       
  
  dev.copy2pdf( file="Means_Electr_Demand_Exp1_Comparisons.pdf",   width=30)
  
  # Tobit Means
  
  if(ModelNr==1)
  { meansTobit_dataframe <- Prediction_List[[ModelNr]][,c("Predict_Tobit_mean")] }  else{       
    meansTobit_dataframe <- data.frame(meansTobit_dataframe,Prediction_List[[ModelNr]][,c("Predict_Tobit_mean")])}         
  
  
  barplot(height=
    t(meansTobit_dataframe), beside=TRUE, main="Tobit Means", col=1:ModelNr)
  
  
  
  legend(x="topright", legend= legendvec,  col = 1:ModelNr,
         border="black", lty=1, lwd=2, pch="-",
         bty = "n", bg = par("bg"))                       
  
  dev.copy2pdf( file="Means_Electr_Demand_Tobit_Comparisons.pdf",  width=30)
  
  # write out data
  write.csv( file="Sums_Exp.csv" ,    x= sumsExp1_dataframe)
  write.csv( file="Means_Exp.csv"  ,  x=  meansExp1_dataframe)
  write.csv( file="Sums_Tobit.csv"  , x= sumsTobit_dataframe)
  write.csv( file="Means_Tobit.csv"  , x= meansTobit_dataframe)
  
  
  ##############################################  
  regresults.Tobit<- coeftest(TobitMod1)[ , c(1,2,3,4) ]                 
  regresults.Tobit<- as.data.frame(regresults.Tobit)
  
  regresults.Tobit$stars.Tobit<- ""
  regresults.Tobit$stars.Tobit[regresults.Tobit[ , 4]<.05 & is.na(regresults.Tobit[,4])==FALSE]<-rep("*"    ,times=length(regresults.Tobit$stars.Tobit[regresults.Tobit[,4]<.05 & is.na(regresults.Tobit[,4])==FALSE]) )
  regresults.Tobit$stars.Tobit[regresults.Tobit[ , 4]<.01 & is.na(regresults.Tobit[,4])==FALSE]<-rep("**"   ,times=length(regresults.Tobit$stars.Tobit[regresults.Tobit[,4]<.01& is.na(regresults.Tobit[,4])==FALSE]) )
  regresults.Tobit$stars.Tobit[regresults.Tobit[ , 4]<.001& is.na(regresults.Tobit[,4])==FALSE]<-rep("***"  ,times=length(regresults.Tobit$stars.Tobit[regresults.Tobit[,4]<.001& is.na(regresults.Tobit[,4])==FALSE]) )
  
  regresults.Exp<- coeftest(expMod1)[ , c(1,2,3,4) ]                 
  regresults.Exp<- as.data.frame(regresults.Exp)
  
  regresults.Exp$stars.Tobit<- ""
  regresults.Exp$stars.Tobit[regresults.Exp[ , 4]<.05 & is.na(regresults.Exp[,4])==FALSE]<-rep("*"    ,times=length(regresults.Exp$stars.Tobit[regresults.Exp[,4]<.05 & is.na(regresults.Exp[,4])==FALSE]) )
  regresults.Exp$stars.Tobit[regresults.Exp[ , 4]<.01 & is.na(regresults.Exp[,4])==FALSE]<-rep("**"   ,times=length(regresults.Exp$stars.Tobit[regresults.Exp[,4]<.01 & is.na(regresults.Exp[,4])==FALSE]) )
  regresults.Exp$stars.Tobit[regresults.Exp[ , 4]<.001& is.na(regresults.Exp[,4])==FALSE]<-rep("***"  ,times=length(regresults.Exp$stars.Tobit[regresults.Exp[,4]<.001& is.na(regresults.Exp[,4])==FALSE]) )
  
  regresults.Exp<-rbind(regresults.Exp, c(NA,NA, NA, NA,""))
  
  regresults<- data.frame(regresults.Exp, regresults.Tobit)
  
  results.table<-regresults[,c(1,2,5,6,7,10)]
  rownames(results.table)<-c("intercept",variables[choice], "sigma")
  colnames(results.table)<- c("Exp Est.Coef", "Exp St.Err", " ", "Tob Est.Coef", "Tob St.Err"," ")
  
  write.csv(file=paste("Results_regressions",ModelNr,".csv", sep=""), x=results.table)
  
}        

 ####
 # Continue with the part3 file
 # "Electricity_Demand_Estimation_Kenya_v13_part3_model_comparison.R"  


