# This is the file to make predictions which should be run after
# the part1 and part2 files have been run
# use data provided by IIASA
IIASAdata<-matrix(c(12.361,15.768,22.607,
                    6.408, 7.831,	9.717,
                    7.429, 9.063,	13.826,
                    28.387,  31.800,	38.208,
                    7.76,  8.32,	9.43
                    ), byrow=TRUE, ncol=3)
colnames(IIASAdata)<-c("2005","2010","2020")
rownames(IIASAdata)<-c("GDPurban","GDPrural", "POPurban","POPrural", "EDUall")

GDPchangeUrban<-(IIASAdata[1,3]-IIASAdata[1,1])/IIASAdata[1,1]
GDPchangeRural<-(IIASAdata[2,3]-IIASAdata[2,1])/IIASAdata[2,1]
POPchangeUrban<-(IIASAdata[3,3]-IIASAdata[3,1])/IIASAdata[3,1]
POPchangeRural<-(IIASAdata[4,3]-IIASAdata[4,1])/IIASAdata[4,1]
EDUchange     <-(IIASAdata[5,3]-IIASAdata[5,1])/IIASAdata[5,1]

electken2020<-electken1[,c(variables[choice], "non_food_exp_person", "weight", "ed")]


# replace non_food_expenditures
electken2020$non_food_exp_person[electken1$rural==0]<- 
  electken1$non_food_exp_person[electken1$rural==0]*(1+GDPchangeUrban)
electken2020$non_food_exp_person[electken1$rural==1]<- 
  electken1$non_food_exp_person[electken1$rural==1]*(1+GDPchangeRural)
electken2020$ihs_non_food_exp_person<-ihs(electken2020$non_food_exp_person)
# replace for education
electken2020$edu[]<- 
  electken1$edu[]*(1+EDUchange)


#### Exponential model
  # Prediction: predict for the household of the sample and multiply by the weights
    predict2020Exp1_unweighted<-predict(expMod1, electken2020)
    predict2020Exp1_weighted<-predict2020Exp1_unweighted*electken1$weight

   # Multiply by the population growth:
    predict2020Exp1_weighted[electken1$rural==0]<- 
     predict2020Exp1_weighted[electken1$rural==0]*(1+POPchangeUrban)
    predict2020Exp1_weighted[electken1$rural==1]<- 
      predict2020Exp1_weighted[electken1$rural==1]*(1+POPchangeRural)

   # Predicted Sum of electricity demand in each district
     Predict2020Exp1_sum<-tapply(X=predict2020Exp1_weighted,INDEX=electken1$district,FUN=sum, na.rm=TRUE)


#### Tobit model
   # Prediction: predict for the household of the sample and multiply by the weights
     predict2020Tob1_unweighted <- predictmhurdleTobit(TobitMod1, data= electken2020[,c(variables[choice])])#electken1[,names(TobitMod1$model[,-c(1,ncol(TobitMod1$model))])])
     predict2020Tob1_weighted<-predict2020Tob1_unweighted*electken1$weight

  # Multiply by the population growth:
     predict2020Tob1_weighted[electken1$rural==0]<- 
      predict2020Tob1_weighted[electken1$rural==0]*(1+POPchangeUrban)
     predict2020Tob1_weighted[electken1$rural==1]<- 
       predict2020Tob1_weighted[electken1$rural==1]*(1+POPchangeRural)

   # Predicted Sum of electricity demand in each district
    Predict2020_Tob1_sum<-tapply(X=predict2020Tob1_weighted,INDEX=electken1$district,FUN=sum, na.rm=TRUE)

  Predict2020<-cbind(Predict2020Exp1_sum,Predict2020_Tob1_sum) 
       colnames(Predict2020)<-c("Exp2020","Tobit2020")
    write.csv(Predict2020, "Prediction_2020.csv")